#ifndef FUPERMOD_BCAST_H_
#define FUPERMOD_BCAST_H_

#include <mpi.h>

typedef enum fupermod_bcast_algo {
  lin,
  binary,
  flat,
  binomial,
  original,
  scatter_lr_allgather
} fupermod_bcast_algo;

void fupermod_bcast(void *buffer, int count, MPI_Datatype datatype,
    int root, MPI_Comm comm, fupermod_bcast_algo algorithm);

void bcast_scatter_lr_allgather(void * buff, int count, MPI_Datatype data_type,
		int root, MPI_Comm comm);

#endif /*FUPERMOD_BCAST_H_*/
