#ifndef MEMORY_HYBRID_H
#define MEMORY_HYBRID_H

#include <stdio.h>
#include <stdlib.h>


#ifdef __cplusplus
extern "C" {
#endif

int malloc_hybrid(int size, double **A, memoryMode MEM_MODE);
int free_hybrid(double *A, memoryMode MEM_MODE);
int initializeMatrix(int M, int N, double *A);
int initializeMatrixToZero(int M, int N, double *A);
int printMatrix(int M, int N, double *A);

int malloc_cuda (int size, double **A, memoryMode MEM_MODE);
int free_cuda (double *A, memoryMode MEM_MODE);

#ifdef __cplusplus
}
#endif

#endif

