#ifndef FUPERMOD_MODEL_PIECEWISE_H_
#define FUPERMOD_MODEL_PIECEWISE_H_

#include "fupermod_model.h"

#ifdef __cplusplus
extern "C" {
#endif

  /*! Piecewise model */
  typedef struct fupermod_model_piecewise {
    /*! Base */
    fupermod_model base;
    /*! Number of points */
    int count;
    /*! Problem size */
    double* d;
    /*! Speed */
    double* s;
  } fupermod_model_piecewise;

#ifdef __cplusplus
}
#endif

#endif /* FUPERMOD_MODEL_PIECEWISE_H_ */
